﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.32
@EndOfDesignText@
'version 1.00
Sub Class_Globals
	Private fx As JFX
'	Type ExpItemData (CollapsedHeight As Int, ExpandedHeight As Int, Value As Object, Expanded As Boolean)
	Private mCLV As CustomListView
	Private mSCM As udtScheme
	Private mTitle, mName As String
	Private xui As XUI
	Private lbl1, lbl2, lbl3, lbl4 As B4XView		'Ignore
	Private pnlTabFixed As B4XView					'Ignore
	Private clvTD As CustomListView
	Private ArrowLastClicked As B4XView
	Private mLayoutName As String
	Private ExpandedIndex As Int
	Private mCLVItemHeight, MaxUnscrolledmCLVRows As Int
	Private UsemCLVScrollBars As Boolean
	Private TDTextFieldNo, MaxclvTDHeight, TDLineHeight, TDCharsPerLine As Int
	Private mapTDRS As Map
	Private LEFT_ARROW As String = Chr(0xF0D9)
	Private DOWN_ARROW As String = Chr(0xF0D7)
	
	Private TestQty As Int = 20
End Sub

Public Sub Initialize (Title As String, Name As String, clv As CustomListView, Scheme As udtScheme)
	mCLV = clv
	mSCM = Scheme
	mTitle = Title
	mName = Name
	' For mCLV:
	' Set the mCLV background transparent
	CallSubDelayed(Me, "Set_ScrollPaneBackgroundTransparent")
	mCLVItemHeight = 40dip
	' Set the maximum number of mclvitems before requiring scrollbars
	MaxUnscrolledmCLVRows = 16
	' For clvTD:
	' Which Field number in a map to find the TD Text line
	TDTextFieldNo = 2
	TDLineHeight = 24
	' Need more work on this number but this is pretty close for small words:
	TDCharsPerLine = 135
	' Set the maximum height of the expanded clvTD. Assumes one mCLV item above and one below.
	MaxclvTDHeight = (MaxUnscrolledmCLVRows-2)*(mCLVItemHeight+mCLV.DividerSize)
	' Initial setting:
	ExpandedIndex = -1
	
	' For testing:
	mapTDRS.Initialize

	' mNames are:
	' PrimaryGroups
	' Collections
	' Recordings
	' PiecesOnly
	' and? NowPlaying?
	' Create 1 layout in Designer for each Order, change the color on state change (N, S, A) (2 x 4 layouts)
	' Layout Names: mName & "_0" and mName & "_1"
End Sub

Public Sub setLayoutName
	mLayoutName = $"${mName}_$1.0{0}"$
End Sub

Private Sub Set_ScrollPaneBackgroundTransparent
	Dim SP As JavaObject = mCLV.GetBase.GetView(0)
	Dim V As B4XView = SP
	V.Color = xui.Color_Transparent
	Dim V As B4XView = SP.RunMethod("lookup", Array(".viewport"))
	V.Color = xui.Color_Transparent
End Sub

Public Sub Clear
	mCLV.clear
End Sub
' Fill the items list with blank panels
Sub LazyLoad_FillList (mapRS As Map)
	Dim n As Long = DateTime.Now
	' TBD when we know how we want to use the id
	Dim ItemID As Int
	' Are we using Scrollbars? Assume a fixed height for all the mCLV items
	' 2 Labels, total height mclvItemHeight for the (unexpanded) item, 16 items in the visible area.
	UsemCLVScrollBars = mapRS.Size > MaxUnscrolledmCLVRows
	' Always reset the Layout name before filling, to use the latest ColOrder
	setLayoutName
	' Get the first row
	Dim Row() As String
	' Empty the items list
	mCLV.Clear
	' Set the ExpandedIndex to -1. This will change to reflect the Index of an expanded item,
	' and allows us to collapse an expanded item when we click on the arrow of a different unexpanded one.
	ExpandedIndex = -1
	'
	If UsemCLVScrollBars Then
		Set_ScrollBars(mCLV, True)
	Else
		Set_ScrollBars(mCLV, False)
	End If
	' And fill the mCLV items list with empty panels
	For r = 0 To mapRS.Size-1
		Row = mapRS.GetValueAt(r)
		Dim pnlFixedItem As B4XView = xui.CreatePanel("")
		'' This is the critical one
		pnlFixedItem.SetLayoutAnimated(0, 0, 0, mCLV.AsView.Width, mCLVItemHeight)
		Dim uFixedItem As udtDisplayItem
		uFixedItem.Initialize
		uFixedItem.ID = ItemID
		' Initially
		uFixedItem.ExpandedHeight = pnlFixedItem.Height
		uFixedItem.Row = Row
		uFixedItem.State = "N"
		mCLV.Add(pnlFixedItem, uFixedItem)
	Next
'	For r = 0 To 20
'		Row = mapRS.GetValueAt(r)
'		Dim pnlItem As B4XView = xui.CreatePanel("")
'		pnlItem.SetLayoutAnimated(0, 0, 0, mCLV.AsView.Width, mclvItemHeight)
'		Dim uDisplayItem As udtDisplayItem
'		uDisplayItem.Initialize
'		uDisplayItem.ID = ItemID
'		uDisplayItem.Row = Row
'		uDisplayItem.State = "N"
'		mCLV.Add(pnlItem, uDisplayItem)
'	Next
'	For r = 21 To LastRow
'		Row = mapRS.GetValueAt(r)
'		Dim pnlItem As B4XView = xui.CreatePanel("")
'		pnlItem.SetLayoutAnimated(0, 0, 0, mCLV.AsView.Width, mclvItemHeight)
'		Dim uDisplayItem As udtDisplayItem
'		uDisplayItem.Initialize
'		uDisplayItem.ID = ItemID
'		uDisplayItem.Row = Row
'		uDisplayItem.State = "N"
'		mCLV.Add(pnlItem, uDisplayItem)
'	Next
	Log("Loading (empty) rows took: " & (DateTime.Now - n) & "ms")
End Sub
' Add details for a range of items
Public Sub VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim ExtraSize As Int = 20
'	Dim ExtraSize As Int = 50
'	Dim ExtraSize As Int = 10
	For i = Max(0, FirstIndex - ExtraSize) To Min(LastIndex + ExtraSize, mCLV.Size - 1)
		Dim pnlItem As B4XView = mCLV.GetPanel(i)
		If pnlItem.NumberOfViews = 0 Then
			Dim uDisplayItem As udtDisplayItem
			uDisplayItem = mCLV.GetValue(i)
			pnlItem.LoadLayout(mLayoutName)
			lbl1.Text = uDisplayItem.Row(1)
			lbl2.Text = uDisplayItem.Row(2)
			If lbl3.IsInitialized Then lbl3.Text = uDisplayItem.Row(3)
			If lbl4.IsInitialized Then lbl4.Text = uDisplayItem.Row(4)
		End If
	Next
End Sub
' Return the State of the item at the index passed in - N, S or A
Public Sub get_ItemState (Index As Int) As String
	Dim uDisplayItem As udtDisplayItem
	uDisplayItem = mCLV.GetValue(Index)
	Return uDisplayItem.State
End Sub
' Set the State of the Item
Public Sub Set_ItemState (Index As Int, State As String)
	Dim uDisplayItem As udtDisplayItem
	uDisplayItem = mCLV.GetValue(Index)
	' Set the new state
	uDisplayItem.State = State
	' Set the background colour to match the new state
	Set_ItemBGToMatchState (Index)
End Sub
' Set background colour of an itme to match its state (N, S or A)
Public Sub Set_ItemBGToMatchState (Index As Int)
	Dim pnlItem As B4XView = mCLV.getpanel(Index)
	If pnlItem.NumberOfViews > 0 Then
		' Get the panel
		Dim pnl As Pane = pnlItem.getview(0)
		' Get the Item Value
		Dim uDisplayItem As udtDisplayItem
		uDisplayItem = mCLV.GetValue(Index)
		' Set the colours depending on the state
		Select uDisplayItem.State
			Case "N"
				CSSUtils.SetStyleProperty(pnl,"-fx-background-color", _
					$"linear-gradient(${mSCM.TextLightBackgroundColor}, ${mSCM.TextBackgroundColor})"$)
			Case "S"
				CSSUtils.SetStyleProperty(pnl,"-fx-background-color", _
					$"linear-gradient(${mSCM.TextBackgroundColor}, ${mSCM.SelectedBackgroundColor})"$)
			Case "A"
				CSSUtils.SetStyleProperty(pnl,"-fx-background-color", _
					$"linear-gradient(${mSCM.SelectedBackgroundColor},${mSCM.ActivatedBackGroundColor})"$)
		End Select
	End If
End Sub

Public Sub ExpandItem (index As Int)
'	Wait for (Main.Fill_CLVTracks(clvTD, Group)) complete 
	' Load the test data
	Fill_TDMapwithTextItems(TestQty)
	Resize_ExpandableItem(index, False)
End Sub

Sub CollapseItem(index As Int)
	Resize_ExpandableItem(index, True)
End Sub

Private Sub Resize_ExpandableItem (Index As Int, Collapse As Boolean)
	' Log("Sub Resize_ExpandableItem")
	Dim Fixeditem As CLVItem = mCLV.GetRawListItem(Index)
	Dim p As B4XView = Fixeditem.Panel.GetView(0)
'	Dim uFixedItem As udtDisplayItem = Fixeditem.value
	If p.NumberOfViews = 0 Then Return
	Dim NewSize, PanelWidth As Int
	Dim NewPanel As B4XView = xui.CreatePanel("")
	Dim clvTDHeight As Int
	' If the panel is being collapsed
	If Collapse Then
		' Collapsing the ExpnadableItem. Empty the clvTD
		clvTD.Clear
		' Set the size to the collapsed height
		NewSize = pnlTabFixed.height
	Else
		' Get the height we need for the clvTD panel
		clvTDHeight = TDScrollbars_Needed
		' Determine whether we need scrollbars in the clvTD.
		If clvTDHeight >= MaxclvTDHeight Then
			' If we do, set them
			Set_ScrollBars(clvTD, True)
		Else
			' Othewise
			Set_ScrollBars(clvTD, False)
		End If
		' Must set the width properly here ... the -20 is dependant on the mCLV scrollbars, I think - not the clvTD scrollbars.
		' But if it isn't taken into account the clvTD scrollbars become hidden under the mCLV ones.
		' This is working with Show Scrollbars checked in the clvTD properties.
		If UsemCLVScrollBars Then
			PanelWidth = mCLV.asview.Width-20dip
		Else
			PanelWidth = mCLV.asview.Width
		End If
		' Add the clvTD to the newpanel with the claculated height, leaving space for the fixed item above it.
		NewPanel.AddView(clvTD.asview, 0, mCLVItemHeight, PanelWidth, clvTDHeight)
		' Set the NewPanel layout - on what? - with a height of the clvTDHeight + the pnlFixedTab height
		' and the width based on whether or not mCLV scrollbars are used
		NewPanel.SetLayoutAnimated(0, 0, 0, PanelWidth, pnlTabFixed.Height+clvTDHeight)
		' Add the newpanel to the mCLV scrollpanel
		mCLV.sv.ScrollViewInnerPanel.AddView(NewPanel, 0, Fixeditem.Offset, p.Width, pnlTabFixed.Height+clvTDHeight)
		' Fill the clvTD from the data in the map created by the SQL cmd to download track info
		Fill_clvTDfromMap
		' Set the NewSize
		NewSize = clvTDHeight + pnlTabFixed.height
	End If
	' This code is the same as the original Expandable CLV code:
	mCLV.ResizeItem(Index, NewSize)
	NewPanel.SendToBack
	Sleep(mCLV.AnimationDuration)
	If p.Parent.IsInitialized Then
		MoveItemBetweenPanels(NewPanel, p)
	End If
	NewPanel.RemoveViewFromParent
End Sub

Private Sub MoveItemBetweenPanels (Src As B4XView, Target As B4XView)
' This was the original code in the example in the forum
'	Do While Src.NumberOfViews > 0
'		Dim v As B4XView = Src.GetView(0)
'		v.RemoveViewFromParent
'		Target.AddView(v, v.Left, v.Top, v.Width, v.Height)
	''' This doesn't look right for the last item in the mCLV: 33, 628 in all the others.
	'Log($"MIBP v.height 2: ${v.height}"$)
'	Loop
	
' This works but I don't know why.
	Do While Src.NumberOfViews > 0
		Dim v As B4XView = Src.GetView(0)
		Dim v1 As B4XView = Src.GetView(0).GetView(0)
		v.RemoveViewFromParent
		Target.AddView(v, v.Left, v.top, v.Width, v1.height)
	Loop
End Sub

Sub btnExpand_Click
	Dim v As B4XView = Sender
	Dim Index As Int = mCLV.GetItemFromView(v)
	' If nothing is expanded, expand this one
	If ExpandedIndex = -1 Then
		ExpandItem(Index)
		ExpandedIndex = Index
		v.Text = DOWN_ARROW
	Else
		' If an item is already expanded and it is not this one, collapse the expanded one
		If ExpandedIndex <> Index Then
			CollapseItem(ExpandedIndex)
			' How to we change the arrow on another item?
			ArrowLastClicked.Text = LEFT_ARROW
			' Expand this one
			ExpandItem(Index)
			ExpandedIndex = Index
			v.Text = DOWN_ARROW
		Else
			' If an item is already expanded and it is this one, collapse it
			CollapseItem(Index)
			ExpandedIndex = -1
			v.Text = LEFT_ARROW
		End If
	End If
	' So we can change a not-selected arrow:
	ArrowLastClicked = v
End Sub
' Do the minimum processing to determine if scrollbars are needed in the clvTD
Sub TDScrollbars_Needed As Int
	' Count through the clvTDItems to see if we need scrollbars
	' This must be done and scrollbars set before we start filling the clvTD
	' The clvTDItems are in the mapRS passed in
	Dim TDHeight As Int
	TDHeight = clvTD.DividerSize
	For Each k In mapTDRS.Keys
		Dim row() As String
		row = mapTDRS.Get(k)
		' Each Item has a height of its number of complete or partial rows * TDLineHeight
		TDHeight = TDHeight + Ceil(row(TDTextFieldNo).Length/TDCharsPerLine)*TDLineHeight + clvTD.DividerSize
		If TDHeight > MaxclvTDHeight Then
			' Get out the moment the Result turns positive
			TDHeight = MaxclvTDHeight
			Exit
		End If
		' If this condition is never reached, return the TDHeight so far.
	Next
	Return TDHeight
End Sub

Sub Fill_clvTDfromMap
	For i = 1 To mapTDRS.Size
		' The Text is in the 3rd column (#2)
		Dim Row() As String
		Row = mapTDRS.Get(i)
		Add_TextItem(i, Row(TDTextFieldNo), i)
	Next
End Sub
' Add a text item and return its height
Sub Add_TextItem (Index As Int, sText As String, Value As Object) As Int
	Dim ItemHeight As Int
	' Each Item has a height of its number of complete or partial rows * TDLineHeight
	ItemHeight = Ceil(sText.Length/TDCharsPerLine)*TDLineHeight
	clvTD.AddTextItem(sText, Value)
	clvTD.ResizeItem(Index-1, ItemHeight)
	Dim Trackitem As CLVItem = clvTD.GetRawListItem(Index-1)
	Dim lblTrack As Label
	lblTrack = Trackitem.Panel.GetView(0).GetView(0)
	lblTrack.Alignment = "CENTER_LEFT"
	lblTrack.PrefHeight = Trackitem.Size
	' For testing
	CSSUtils.SetStyleProperty(lblTrack, "-fx-background-color", "DarkGray")
	Return Trackitem.Size
End Sub
' Get the scrollbar visibility of the mCLV
Sub Get_mCLVScrollBarsVisible As Boolean
	Dim jo As JavaObject = mCLV 		'ignore
	Return jo.GetField("_scrollbarsvisible")
End Sub
' Show or hide clv Scrollbars.
Sub Set_ScrollBars(clv As CustomListView, Visible As Boolean)
	Dim nsv As ScrollPane = clv.sv
	If Visible Then
		nsv.SetVScrollVisibility("ALWAYS")
	Else
		nsv.SetVScrollVisibility("NEVER")
	End If
	Dim jo As JavaObject = clv 		'ignore
	jo.SetField("_scrollbarsvisible", Visible)
	'
	clv.Base_Resize(clv.AsView.Width, clv.AsView.Height)
End Sub

Sub clvTrackDisplay_ItemClick (Index As Int, Value As Object)
	Log("TrackDisplay Item Clicked")
	
End Sub
' For testing - will replace this with SQL
Sub Fill_TDMapwithTextItems (Qty As Int)
	mapTDRS.Clear
	' Set this up with rows of PG, TrackNo, Text
	For i = 1 To 3
		Dim Row(4) As String
		Row(0) = "PG_123456789A"
		Row(1) = "01"
		Row(2) = "Item #" & i & ": Short row"
		mapTDRS.Put(i, Row)
	Next
	For i = 4 To 8
		Dim Row(4) As String
		Row(0) = "PG_123456789A"
		Row(1) = "01"
		Row(2) = "Item #" & i & ": This is a very long item, an item that should use up at least two lines  is a very long item, " & _
				"an item that should use up at least two lines."
		mapTDRS.Put(i, Row)
	Next
	For i = 9 To Qty
		Dim Row(4) As String
		Row(0) = "PG_123456789A"
		Row(1) = "01"
		Row(2) = "Item #" & i & ": This is even longer, probably three lines long, a very long item, an item that should " & _
				"use up at least two lines  Is a very long item, an item that should use up at least two lines " & _
									" Item #his is even longer, probably three lines long, a very long item, an item that should use up " & _
									" at least two lines  Is a very long item, an item that should use up at least two lines to there we are in new territory"
		mapTDRS.Put(i, Row)
	Next
End Sub
